package com.maroontress.sanctuary;

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   ¤Τޤ϶Τ˴ޤޤؿݥ󥿷ΥФǤ
*/
public class MethodMember extends Member {

    /** ؿ */
    private Function func;

    /**
       ؿݥ󥿷ΥФޤ

       @param g 饹
       @param parentName °빽¤Τޤ϶Τ̾
       @param elem method
    */
    public MethodMember(final Group g, final QualifiedName parentName,
			final Element elem) {
	super(g, parentName, "", elem);
	QualifiedName name = QualifiedName.intern(getName());
	func = new Function(g, name, getDescription(), elem);
    }

    /**
       {@inheritDoc}
    */
    @Override public void printCode(final PrintWriter wr,
				    final String indent) {
	func.printPrototype(wr, indent, "", ";", "(*", ")", true);
    }

    /**
       {@inheritDoc}
    */
    @Override public void printSummary(final PrintWriter wr) {
	func.printSummary(wr, getParentName() + "." + getName(), "(*", ")");
    }

    /**
       {@inheritDoc}
    */
    @Override public void printDetail(final PrintWriter wr) {
	func.printDetail(wr, getParentName() + "." + getName(), "(*", ")");
    }

    /**
       {@inheritDoc}
    */
    @Override public void printTexDetail(final PrintWriter wr) {
	func.printTexDetail(wr, getParentName() + "." + getName(), "member",
			    "\\begin{Sindentation}{\\Sindentlength}{0pt}",
			    "\\end{Sindentation}", "(*", ")");
    }
}
